/* = Ke2001 DMM Driver Include File ========================================  */
#ifndef __ke2001_HEADER
#define __ke2001_HEADER

#define PUBLIC __stdcall

#if defined(__cplusplus) || defined(__cplusplus__)
extern "C" {
#endif

/*  CONSTANT DECLARATIONS ================================================== */
/*  Replace 10 with the maximum number of devices of this type being used.   */
#define kei2001_MAX_INSTR   10

/*  = GLOBAL FUNCTION DECLARATIONS ==========================================  */
int PUBLIC kei2001_init (int GPIBAddress, int resetDev, int *instrumentID);
int PUBLIC kei2001_change_func (int instrumentID, int function);
int PUBLIC kei2001_conf_chan (int instrumentID, int scanChannel, int function);
int PUBLIC kei2001_conf_volt_curr_res (int instrumentID, int function, double range,
                                int resolution, int coupling,
                                double integrationTime);
int PUBLIC kei2001_conf_freq (int instrumentID, int resolution, int coupling, int source,
                       double range, double level, int TLLInputLevel);
int PUBLIC kei2001_conf_temp (int instrumentID, double integrationTime, int resolution,
                       int transducer, int RTDType, int thermocoupleType);
int PUBLIC kei2001_conf_ave_filter (int instrumentID, int function, int filterState,
                             int autoFilter, int filterType, int filterCount,
                             int advancedFilter, double noiseTolerance);
int PUBLIC kei2001_conf_unit (int instrumentID, int temperature, int ACVoltage,
                       double dBReference, int dBmImpedance);
int PUBLIC kei2001_conf_scanlist (int instrumentID, int numberofChannels,
                           int scanChannels[]);
int PUBLIC kei2001_conf_math (int instrumentID, int mathState, int operation,
                       double percentFactor, double mFactor, double bFactor);
int PUBLIC kei2001_conf_rat_del (int instrumentID, int operation, int function,
                          int measurementChannel, int referenceChannel);
int PUBLIC kei2001_conf_trig_arm (int instrumentID, int armSouce, int infiniteCount,
                           long count, int outputTriggerLine, int inputTriggerLine,
                           int sourceBypass);
int PUBLIC kei2001_conf_trig_scan (int instrumentID, int scanSouce, int infiniteCount,
                            long count, int outputTriggerLine, int inputTriggerLine,
                            int sourceBypass, double delay, double timer);
int PUBLIC kei2001_conf_trig_meas (int instrumentID, int measureSource, int infiniteCount,
                            long count, int outputTriggerLine, int inputTriggerLine,
                            double delay, double timer);
int PUBLIC kei2001_cont_init (int instrumentID, int onOff);
int PUBLIC kei2001_conf_buf (int instrumentID, int dataFormat, int sourceofReadings,
                      int autoBufferSizing, long bufferSize, int bufferControlMode,
                      double pretriggerReading, int pretriggerSource);
int PUBLIC kei2001_conf_syst_setup (int instrumentID, int autoZeroState, int autoZeroMode,
                             int lineSynchronization);
int PUBLIC kei2001_conf_acq_method (int instrumentID, int acquisitionMethod);
int PUBLIC kei2001_sing_meas (int instrumentID, int operation, int channel, double *result);
int PUBLIC kei2001_start_meas (int instrumentID, int operation, int channel);
int PUBLIC kei2001_check_meas (int instrumentID, int *status);
int PUBLIC kei2001_retrieve_meas (int instrumentID, int *numberofReadings,
                           double readings[]);
int PUBLIC kei2001_calc_buf (int instrumentID, int state, int format, double *result);
int PUBLIC kei2001_to_file (int instrumentID, char fileName[], int mode, int *size);
int PUBLIC kei2001_ret_read (char fileName[], int offset, int skipPoints, int size,
                      double reading[], int unit[], int status[],
                      double timeStamp[], int channelNumber[]);
int PUBLIC kei2001_trig_reset (int instrumentID);
int PUBLIC kei2001_preset (int instrumentID);
int PUBLIC kei2001_reset (int instrumentID);
int PUBLIC kei2001_wait (int instrumentID);
int PUBLIC kei2001_bus_trig (int instrumentID);
int PUBLIC kei2001_open_chan (int instrumentID, int channel);
int PUBLIC kei2001_dig_polarity (int instrumentID, int portPolarity);
int PUBLIC kei2001_dig_out (int instrumentID, int portPattern);
int PUBLIC kei2001_dig_in (int instrumentID, int *reading);
int PUBLIC kei2001_disp_msg (int instrumentID, int display, char message20Char[]);
int PUBLIC kei2001_read_instr_err (int instrumentID, int *errorCode, char errorMessage[]);
int PUBLIC kei2001_buf_clear (int instrumentID);
int PUBLIC kei2001_sav_rec_setup (int instrumentID, int saveRecall, int saveRecallLocation);
int PUBLIC kei2001_goto_local (int instrumentID);
int PUBLIC kei2001_close (int instrumentID);

#if defined(__cplusplus) || defined(__cplusplus__)
!}
#endif

/*****************************************************************************/
/*=== END INCLUDE FILE ======================================================*/
/*****************************************************************************/

#endif
